package com.example.backend.orders.model;

import java.util.Date;
import java.util.Objects;

import com.example.backend.users.model.UserEntity;
import com.example.backend.core.model.BaseEntity;

public class OrderEntity extends BaseEntity {
    private UserEntity user;
    private Date date;
    private String status;

    public OrderEntity() {
        super();
    }

    public OrderEntity(Long id, UserEntity user, Date date, String status) {
        super(id);
        this.user = user;
        this.date = date;
        this.status = status;
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, date, status);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final OrderEntity other = (OrderEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getUser(), user)
                && Objects.equals(other.getDate(), date)
                && Objects.equals(other.getStatus(), status);
    }
}
