package com.example.backend.ordersbooks.model;

import java.util.Objects;

import com.example.backend.books.model.BookEntity;
import com.example.backend.orders.model.OrderEntity;
import com.example.backend.core.model.BaseEntity;

public class OrderBookEntity extends BaseEntity {
    private OrderEntity order;
    private BookEntity book;
    private Integer count;

    public OrderBookEntity() {
        super();
    }

    public OrderBookEntity(Long id, OrderEntity order, BookEntity book, Integer count) {
        super(id);
        this.order = order;
        this.book = book;
        this.count = count;
    }

    public OrderEntity getOrder() {
        return order;
    }

    public void setOrder(OrderEntity order) {
        this.order = order;
    }

    public BookEntity getBook() {
        return book;
    }

    public void setBook(BookEntity book) {
        this.book = book;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, order, book, count);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final OrderBookEntity other = (OrderBookEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getOrder(), order)
                && Objects.equals(other.getBook(), book)
                && Objects.equals(other.getCount(), count);
    }
}
